/*
  Panda LED Demo v1 (Nano) | Mete Hoca Panda'nın Kullanım Örnekleri

  Mete Hoca Panda ile oyunlar geliştirebilmek için LED'leri kullanma şekillerini
  ve animasyon örneklerini içerir.

  Panda LED Demo v1 Web Sayfası: https://www.metehoca.com/

  --------------------------------------------------------------------------------

  Mete Hoca Panda | Eğlendirerek Arduino Kodlama Öğreten Mini Oyun Konsolu
 
  Mete Hoca Panda, Arduino Nano veya Raspberry Pi Pico ile kullanılan ve herkesin
  kendi basit oyunlarını tasarlayıp uygulayabileceği kolay ve esnek bir oyun
  platformudur.

  1 veya 2 kişilik oyunlar geliştirilmesine açık olan Panda, üzerinde barındırdığı
  3 programlanabilir buton, 16 LED, 2 anahtar ve 1 buzzer ile biz Arduino ve
  Raspberry Pi Pico tutkunlarına hayal gücümüz ile sınırlı pek çok eğlence sunuyor.
  
  Panda'nın detaylı açıklaması ve örnek oyunlarını web sitemizde bulabilirsiniz.
 
  Mete Hoca
  https://www.metehoca.com/
*/

const byte LED[16] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,A0,A1}; // LED'lerin pinleri

byte ButonA = A2, ButonB = A3, ButonS = A4; // Buton pinleri
byte SwitchX = A6, SwitchY = A7;            // Anahtar pinleri
byte Buzzer = A5;                           // Buzzer pini

int AnahtarX, AnahtarY, t, h;

void setup() {
  Kurulum();                                // LED ve Butonları ayarlar
  AnahtarOku();                             // Anahtar konumlarını okur

  // Tek LED ile tam tur dönelim
  for (int x = 0; x < sizeof(LED); x++){
    digitalWrite(LED[x], HIGH);
    delay(100);
    digitalWrite(LED[x], LOW);
  }
  delay(1000);
  
  // LED'leri sırayla yakalım
  for (int x = 0; x < sizeof(LED); x++){
    digitalWrite(LED[x], HIGH);
    delay(100);
  }
  
  // Şimdi de sırayla söndürelim
  for (int x = 0; x < sizeof(LED); x++){
    digitalWrite(LED[x], LOW);
    delay(100);
  }
  delay(1000);
}

void loop() {
  // LEDçekimi döngüsü :)
  // X anahtarı buzzer'ı açar veya kapatır
  // Y anahtarı döngü hızını kontrol eder
  AnahtarOku();
  if (AnahtarY == 1) {
    t = 225; h = 25;
  } else {
    t = 450; h = 50; }
  
  for (int x = 0; x < 9; x++){
    digitalWrite(LED[x], HIGH);
    if (AnahtarX == 2) tone(Buzzer,1000-t);
    delay(t);
    t -= h;
    digitalWrite(LED[x], LOW);
    noTone(Buzzer);
  }
  for (int x = 9; x < sizeof(LED); x++){
    digitalWrite(LED[x], HIGH);
    if (AnahtarX == 2) tone(Buzzer,1000-t);
    t += h;
    delay(t);
    digitalWrite(LED[x], LOW);
    noTone(Buzzer);
  }
}

void AnahtarOku() {
  AnahtarX = analogRead(SwitchX);                                         // Analog değeri oku
  if (AnahtarX > 900) AnahtarX = 1; else if (AnahtarX < 50) AnahtarX = 2; // 1 veya 2 olarak ayarla
  AnahtarY = analogRead(SwitchY);                                         // Analog değeri oku
  if (AnahtarY > 900) AnahtarY = 1; else if (AnahtarY < 50) AnahtarY = 2; // 1 veya 2 olarak ayarla
}

void Kurulum() {
  for (int x = 0; x < sizeof(LED); x++) pinMode(LED[x], OUTPUT);          // LED'leri çıkış yapıyoruz
  pinMode(ButonA, INPUT);            // Buton pinlerini giriş olarak ayarlıyoruz
  pinMode(ButonB, INPUT);
  pinMode(ButonS, INPUT);
  pinMode(Buzzer, OUTPUT);           // Buzzer pinini çıkış olarak ayarlıyoruz
  for (int x = 0; x < sizeof(LED); x++) digitalWrite(LED[x], HIGH);       // Test: Tüm LED'leri yakalım
  delay(500);
  for (int x = 0; x < sizeof(LED); x++) digitalWrite(LED[x], LOW);        // LED'leri söndürelim
  delay(500);                        // Ana kod öncesinde biraz bekleyelim
}
